import { PureComponent } from 'react';
import { Animated, TouchableOpacity, TouchableNativeFeedback, ViewStyle, TextStyle } from 'react-native';
interface Props {
    containerStyle: ViewStyle;
    buttonStyle: ViewStyle;
    title: string;
    titleStyle: TextStyle;
    titleProps: object;
    loadingStyle: TextStyle;
    loadingProps: object;
    onPress: () => void;
    TouchableComponent: TouchableNativeFeedback | TouchableOpacity;
    duration: number;
    raised: boolean;
    disabled: boolean;
    disabledStyle: ViewStyle;
    useNativeDriver: boolean;
}
export default class AnimatedLoadingButton extends PureComponent<Props> {
    static defaultProps: {
        containerStyle: {
            width: string;
            height: number;
        };
        buttonStyle: {
            backgroundColor: string;
            borderRadius: number;
            paddingHorizontal: number;
        };
        title: string;
        titleStyle: {
            color: string;
        };
        titleProps: {};
        loadingStyle: {
            color: string;
        };
        loadingProps: {};
        TouchableComponent: any;
        duration: number;
        raised: boolean;
        disabled: boolean;
        disabledStyle: {};
        useNativeDriver: boolean;
    };
    state: {
        loading: boolean;
    };
    containerWidth: number;
    containerHeight: number;
    loadingValue: {
        maxWidth: Animated.Value;
        borderRadius: Animated.Value;
        opacity: Animated.Value;
    };
    constructor(props: Props);
    get borderRadius(): number;
    setLoading: (loading: boolean) => void;
    animateButton(maxWidthEnd: any, borderRadiusEnd: any, opacityEnd: any): void;
    onLayout: (e: any) => void;
    renderLoading(): JSX.Element;
    renderTitle(): JSX.Element;
    render(): JSX.Element;
}
export {};
